use tosin::Settings;
use tosin::contrib::admin;
use tosin::urls::{UrlMap, url_map};

mod polls;

fn urls() -> UrlMap {
    url_map! {
        "polls" / ..polls::urls(),
        "admin" / ..admin::site::urls(),
    }
}

fn settings() -> Settings {
    Settings {
        installed_apps: &[
            &polls::APP,
            &admin::APP,
        ],
        database_url: "example_data.sqlite3",
        ..Settings::default()
    }
}

tosin::main!(urls(), settings());
